<?php


// --------------------------------------------------------------------------------
// Booking Wizard plugin module, version 1.1
// --------------------------------------------------------------------------------
// License GNU/LGPL - Chuck Pettigrew - November 2009
// http://www.bellsidedesigns.co.uk
// --------------------------------------------------------------------------------
//


/*
Plugin Name: Booking Wizard
Plugin URI: http://www.bookingwizard.net
Description: Booking Wizard widget plugin.  Add availability calendars, availability search and also an administration widget directly into your wordpress site.  The demo mode is available immediately, but your need to <a href="http://www.bookingwizard.net/?c=register" target=bd>register here</a> to define your own properties.  To find out more, <a href="http://www.bookingwizard.net" target=bd>visit our site</a>.
Version: 1.1
Author: Chuck Pettigrew
Author URI: http://www.bellsidedesigns.co.uk
*/


global $book;

$book['lang'] = get_option("book_lang", "en");
$book['account'] = get_option("book_accountid", "demoAccount");
$book['layout'] = get_option("book_layout", "classic");
$book['classid'] = get_option("book_classname", "book");
$book['debug'] = get_option("book_borders", "1");



function booking_wizard() {

	$option1 = get_option("book_lang");
	print_r($option1);

}

function booking_init() {
	return get_option("book_lang");
}


function booking_filter($content) {
		global $book;

		$newContent=booking_filterContent($content, '/\[\[booking (.*)\]\]/', $book);

		return $newContent;

}



function booking_filterContent($content, $expression, $config) {

		switch($config['layout']) {
			default:
			case "classic":
				$config['height']="420";
				$config['width']="630";
				break;

			case "banner":
				$config['height']="220";
				$config['width']="700";
				break;

			case "tower":
				$config['height']="550";
				$config['width']="210";
				break;
		}

		$runLocal=false;
		$subDom="www";
		if ($runLocal) {
			$subDom="loc";
		}
		$scriptExtra='';

		$output='<script type="text/javascript" src="http://'.$subDom.'.bookingwizard.net/js/Calendar.js?ver=1"></script>';
				
		// find tags in content-text
		preg_match_all($expression, $content, $matches);
		$cnt=0;
		if ( isset($matches[1])) {
			foreach($matches[1] as $wparam ) {
				@list(, $replStr) = each($matches[0]);
				@list($type,$code,$style) =  split(",",$wparam,3);
				$type=trim($type);
				$code=trim($code);
				$style=trim($style);

				switch($type) {

					case "administration":
						if ( $runLocal ) {
							$scriptExtra='admin.setSub("lportal");';
						}
						$output = '<div class='.$config['classid'].'_admin style="'.$code.'" id=targ_admin></div>
							<script type="text/javascript" src="http://'.$subDom.'.bookingwizard.net/js/Admin.js"></script>
			<script type="text/javascript">
			<!--
				var admin = new Admin(720, 600, "'.$config['account'].'");
				admin.setTarget("targ_admin");
				admin.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				admin.show();
			-->
			</script>';
					break;

					case "availability":
						if ( $runLocal ) {
							$scriptExtra='avail.setSub("lportal");';
						}
						$output .= '<div class='.$config['classid'].'_avail style="'.$code.'" id=targ_avail></div>
			<script type="text/javascript">
			<!--
			var avail = new Availability(180, 550, "'.$config['account'].'" );
				avail.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				avail.setLanguage("'.$config['lang'].'");
				avail.setTarget("targ_avail");
				avail.show();
			-->
			</script>';
					break;

					case "property":

						$cnt++;
						if ( $runLocal ) {
							$scriptExtra='cal'.$cnt.'.setSub("lportal");';
						}

						$output .= '<div class='.$config['classid'].'_property  style="'.$style.'" id=targ_'.$code.'></div>
			<script type="text/javascript">
			<!--
				//
				var cal'.$cnt.' = new Calendar('.$config['width'].', '.$config['height'].', "'.$code.'", "'.$config['account'].'");
				cal'.$cnt.'.layout("'.$config['layout'].'");
				cal'.$cnt.'.setFrameBorder('.$config['debug'].');
				'.$scriptExtra.'
				cal'.$cnt.'.setLanguage("'.$config['lang'].'");
				cal'.$cnt.'.setTarget("targ_'.$code.'");
				cal'.$cnt.'.show();
			-->
			</script>';
					break;

				default:
					$output.="<div style='color:red; font-weight: bold;'>Booking Error: Unkown type entered into the Plugin environment : $replStr<br>Check Syntax.</div>";
					break;

				}
						
				
				$content = str_replace($replStr, $output, $content);			
				$output="";

			}	
		}

	return $content;
}


function booking_menu() {
	add_options_page(
		'Booking Wizard', 'Booking Wizard', 'manage_options', _File_, 'admin_booking_options'
	);
}	

function admin_booking_options() {
	print ("<h2>Booking Wizard Options</h2>");
	if ($_REQUEST['submit']) {
		update_booking_options();
	}
	print_booking_form();
}

function update_booking_options() {
	foreach(array("book_lang","book_accountid","book_layout","book_classname","book_borders") as $key) {
		if (isset($_REQUEST[$key])) {
			update_option($key, $_REQUEST[$key]);
		}
	}
}

function print_booking_form() {

	$def_book_lang = get_option("book_lang", "en");
	$def_book_accountid = get_option("book_accountid", "demoAccount");
	$def_book_layout = get_option("book_layout", "classic");
	$def_book_classname = get_option("book_classname", "book");
	$def_book_borders = get_option("book_borders", "1");

	print("<div style='width: 600px;'>This plugin displays third party widgets for an online booking wizard and availability system.<p>To get a demo up and running, keep account ID as demoAccount and add the test entries, below, into your content material. <br>
		</div>
<p>
		<form method=post>
		<table border=1 style='border: 1px solid black; width: 500px;'>
		<tr>
		<td>&nbsp<br>&nbsp;</td>
		<td align=center>
		<label for='book_lang'>Language:</label></td><td><select name='book_lang'>");

	$lang=array(
		"en" => "English",
			'fr' => "French",
			'it' => "Italian",
			'de' => "German",
			'es' => "Spanish",
	);

	foreach($lang as $key => $val ) {
		if ( $key == $def_book_lang ) {
			$selected="selected=yes";
		}
		print("<option $selected value='$key'>$val</option>");
		$selected="";
	}

	print("
		</select>
</td></tr>
<td>&nbsp<br>&nbsp;</td><td align=center>
		<label for='book_accountid'>Account ID:</label></td><td><input type=text name='book_accountid' value='$def_book_accountid'>
</td></tr>
<td>&nbsp<br>&nbsp;</td><td align=center>
<label for='book_layout'>Calendar Layout:</label></td><td>");

	$lang=array(
		"classic" => "Classic",
		'banner' => "Banner",
		'tower' => "Tower",
	);

	foreach($lang as $key => $val ) {
		if ( $key == $def_book_layout ) {
			$selected="checked";
		}
		print("<input $selected type=radio name='book_layout' value='$key'>$val&nbsp;&nbsp;");
		$selected="";
	}

	print ("
</td></tr>
<td>&nbsp<br>&nbsp;</td><td align=center>
		<label for='book_classname'>The class prefix of<br>the surrounding div:</label></td><td><input type=text name='book_classname' value='$def_book_classname'>
</td></tr>
<td>&nbsp<br>&nbsp;</td><td align=center>
<label for='book_borders'>Show frame borders:</label></td><td>");

	$lang=array(
		"1" => "Yes",
		'0' => "No",
	);

	foreach($lang as $key => $val ) {
		if ( $key == $def_book_borders ) {
			$selected="checked";
		}
		print("<input $selected type=radio name='book_borders' value='$key'>$val&nbsp;&nbsp;");
		$selected="";
	}

	print("
</td></tr><td></td>
<td>&nbsp<br>&nbsp;</td><td>
		<input type='submit' name='submit' value='Submit' >
</td></tr></table>
</form>
<p>
<div style='width: 600px;'>
Add the following syntax to your article text to make the widgets appear.  (Do not copy and past in case you paste html hidden codes into your document.)
<P>
For a calendar widget, add: [[booking property,Vista]]
<P>
For Availability widget, add: [[booking availability]]
<P>
For administration widget, add:  [[booking administration]]
<P>
Save the article and now access the article from the main website.  Your widgets should appear inside your content.
</div>	");
		
}

add_action('admin_menu', 'booking_menu');
add_filter('the_content', 'booking_filter');

?>
